'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _lodashArrayUniq = require('lodash/array/uniq');

var _lodashArrayUniq2 = _interopRequireDefault(_lodashArrayUniq);

var _ = require('./');

var _2 = _interopRequireDefault(_);

var _packageJson = require('../package.json');

var _packageJson2 = _interopRequireDefault(_packageJson);

var help = '\n  Usage:\n    crack <options>\n  Options:\n    -p, --paths  <paths>  Overwrite checkout paths\n    -s, --silent          Suppress \'npm test\' output\n    -v, --version         Output the current version\n    -h, --help            Output this help info\n';

exports['default'] = function (argv) {
  var args = _minimist2['default'](argv, {
    string: ['paths'],
    booleans: ['silent', 'help', 'version'],
    alias: {
      p: 'paths',
      s: 'silent',
      h: 'help',
      v: 'version'
    }
  });
  if (args.help) return console.log(help);
  if (args.version) return console.log(_packageJson2['default'].version);
  _2['default']({
    paths: args.paths ? _lodashArrayUniq2['default'](args.paths.split(/ *, */)) : null,
    silent: !!args.silent
  }, function (err, ok) {
    if (err) return console.error(err);
    if (ok) return console.log('no breaking change detected');
    console.log('breaking change detected');
    process.exit(1);
  });
};

module.exports = exports['default'];