'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _child_process = require('child_process');

var _fs = require('fs');

var _gitRefs = require('git-refs');

var _gitRefs2 = _interopRequireDefault(_gitRefs);

exports['default'] = function (opts, callback) {
  if (typeof opts === 'function') {
    var _temp = [null, opts];
    opts = _temp[0];
    callback = _temp[1];
    _temp;
  }
  opts = opts || {};
  opts.paths = opts.paths || ['tests', 'package.json'];
  _child_process.exec('git fetch --tags', function (error, stdout, stderr) {
    if (error) return callback('could not fetch tags');
    _child_process.exec('git describe --abbrev=0 --tags', function (descErr, stdout, stderr) {
      _gitRefs2['default'](function (err, refs) {
        if (err) return callback('could not get refs');
        var cohash = refs.get(descErr ? 'HEAD' : 'tags/' + stdout.trim());
        _child_process.exec('git checkout ' + cohash + ' ' + opts.paths.join(' '), function (error, stdout, stderr) {
          if (error) return callback('could not checkout paths');
          var pkg = JSON.parse(_fs.readFileSync('package.json').toString());
          var tmpDep = pkg.dependencies;
          delete pkg.dependencies;
          _fs.writeFileSync('package.json', JSON.stringify(pkg, null, 2) + '\n');
          _child_process.exec('npm install', function (error, stdout, stderr) {
            if (error) return callback('could not install dependencies');
            pkg.dependencies = tmpDep;
            _fs.writeFileSync('package.json', JSON.stringify(pkg, null, 2) + '\n');
            var npmTest = _child_process.exec('npm test', function (error, stdout, stderr) {
              _child_process.exec('git stash', function () {
                callback(null, !error);
              });
            });
            if (!opts.silent) {
              npmTest.stdout.pipe(process.stdout);
              npmTest.stderr.pipe(process.stderr);
            }
          });
        });
      });
    });
  });
};

module.exports = exports['default'];